/**
 * Roundcube Treelist Widget
 *
 * This file is part of the Roundcube Webmail client
 *
 * @licstart  The following is the entire license notice for the
 * JavaScript code in this file.
 *
 * Copyright (c) 2013-2014, The Roundcube Dev Team
 *
 * The JavaScript code in this page is free software: you can
 * redistribute it and/or modify it under the terms of the GNU
 * General Public License (GNU GPL) as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * any later version.  The code is distributed WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.
 *
 * As additional permission under GNU GPL version 3 section 7, you
 * may distribute non-source (e.g., minimized or compacted) forms of
 * that code without the copy of the GNU GPL normally required by
 * section 4, provided you include this license notice and a URL
 * through which recipients can access the Corresponding Source.
 *
 * @licend  The above is the entire license notice
 * for the JavaScript code in this file.
 *
 * @author Thomas Bruederli <roundcube@gmail.com>
 * @requires jquery.js, common.js
 */
function rcube_treelist_widget(ja,k){var K,L,M;function C(a,b,c){var d;if(d=l[a]){d.collapsed="undefined"==typeof c||c;var e=m(d.id,!0);e.attr("aria-expanded",d.collapsed?"false":"true");e.children("ul").first()[d.collapsed?"hide":"show"]();e.children("div.treetoggle").removeClass("collapsed expanded").addClass(d.collapsed?"collapsed":"expanded");v.triggerEvent("toggle",d);if(b&&d.children)for(e=0;e<d.children.length;e++)C(d.children[e].id,b,c);v.triggerEvent(d.collapsed?"collapse":"expand",d);b=
d.collapsed;k.save_state&&window.rcmail&&(c="treelist-"+U,w||(w=rcmail.local_storage_get_item(c,{})),w[a]!=b&&(w[a]=b,rcmail.local_storage_set_item(c,w)))}}function V(a,b){C(a,b,!1)}function H(a){if(!1!==v.triggerEvent("beforeselect",l[a])&&(n&&(m(n,!0).removeClass("selected").removeAttr("aria-selected"),p&&m(n).removeClass("selected").removeAttr("aria-selected"),n=null),a)){var b=m(a,!0);b.length&&(b.addClass("selected").attr("aria-selected","true"),n=a,p&&m(a).addClass("selected").attr("aria-selected",
"true"),W(b));v.triggerEvent("select",l[a])}}function X(a,b){return m(a,b).get(0)}function Y(a,b){var c,d,e=a.get(0).id,g=a.children().first().text().toUpperCase();a.parent().children("li"+b).each(function(h,q){0==h&&(c=q);if(q.id!=e)if(q.id!=e&&g>=$(q).children().first().text().toUpperCase())d=q;else return!1});d?a.insertAfter(d):c&&c.id!=e&&a.insertBefore(c);r=I(f,0)}function Z(a,b){a=String(a).toLowerCase();if(!a.length)return D();if(a==E&&!b)return 0;var c=[],d=function(e){$.each(e,function(g,
h){if(!h.virtual&&!h.deleted&&0<=String(h.text).toLowerCase().indexOf(a)&&0>c.indexOf(h.id)){g=m(h.id);if(g.data("filtered"))return;$("<li>").attr("id",g.attr("id")+"--xsR").attr("class",g.attr("class")).addClass("searchresult__").append(g.children(":not(div.treetoggle,ul)").clone(!0,!0)).appendTo(f);c.push(h.id)}h.children&&h.children.length&&d(h.children)})};p&&($(f).children("li.searchresult__").remove(),p=!1);$(f).children("li").hide().removeClass("selected");d(r);p=!0;v.triggerEvent("search",
{query:a,last:E,count:c.length,ids:c,execute:b||!1});E=a;return c.count}function D(){N&&N.val("");$(f).children("li.searchresult__").remove();$(f).children("li").filter(function(){return!$(this).data("filtered")}).show();p=!1;v.triggerEvent("search",{query:!1,last:E});E="";n&&H(n)}function A(a,b,c){if(!a.deleted){var d=$("<li>").attr("id",k.id_prefix+(k.id_encode?k.id_encode(a.id):a.id)).attr("role","treeitem").addClass((a.classes||[]).join(" ")).data("id",a.id);c?(c.replaceWith(d),b&&d.appendTo(b)):
d.appendTo(b);"string"==typeof a.html?d.html(a.html):"object"==typeof a.html&&d.append(a.html);a.text||(a.text=d.children().first().text());a.virtual&&d.addClass("virtual");a.id==n&&d.addClass("selected");if(a.children&&a.children.length)for(d.attr("aria-expanded",a.collapsed?"false":"true"),$('<div class="treetoggle '+(a.collapsed?"collapsed":"expanded")+'">&nbsp;</div>').appendTo(d),b=$("<ul>").appendTo(d).attr("class",a.childlistclass).attr("role","group"),a.collapsed&&b.hide(),c=0;c<a.children.length;c++)a.children[c].level=
a.level+1,A(a.children[c],b);return d}}function I(a,b){var c=[];a.children("li").each(function(d,e){e=$(e);var g=e.children("ul"),h={id:B(e),classes:String(e.attr("class")).split(" "),virtual:e.hasClass("virtual"),level:b,html:e.children().first().get(0).outerHTML,text:e.children().first().text(),children:I(g,b+1)};g.length&&(h.childlistclass=g.attr("class"));h.children.length&&(void 0===h.collapsed&&(h.collapsed="none"==g.css("display")),d=aa(h.id,h.collapsed),void 0!==d&&(h.collapsed=d,g[d?"hide":
"show"]()),e.children("div.treetoggle").length||$('<div class="treetoggle '+(h.collapsed?"collapsed":"expanded")+'">&nbsp;</div>').appendTo(e),e.attr("aria-expanded",h.collapsed?"false":"true"));e.hasClass("selected")&&(e.attr("aria-selected","true"),n=h.id);e.data("id",h.id);e.attr("role","treeitem").attr("aria-level",h.level+1);h.virtual&&e.children("a:first").attr("tabindex","0");c.push(h);l[h.id]=h});a.attr("role",0==b?"tree":"group");return c}function ba(a){a.id&&(l[a.id]=a);for(var b=0;a.children&&
b<a.children.length;b++)ba(a.children[b])}function B(a){a=String(a.attr("id")).replace(new RegExp("^"+k.id_prefix||"%"),"").replace(/--xsR$/,"");return k.id_decode?k.id_decode(a):a}function m(a,b){a=k.id_encode?k.id_encode(a):a;return $("#"+k.id_prefix+a+(p&&!b?"--xsR":""),f)}function W(a){var b=f.parent(),c=b.scrollTop(),d=a.offset().top-b.offset().top;(0>d||d+a.height()>b.height())&&b.scrollTop(d+c)}function aa(a){if(k.save_state&&window.rcmail)return w||(w=rcmail.local_storage_get_item("treelist-"+
U,{})),w[a]}function ca(a,b,c){var d=a[0>b?"prev":"next"]();0<b&&!c&&a.children("ul[role=group]:visible").length?a.children("ul").children("li:first").find("a:first").focus():0>b&&!c&&d.children("ul[role=group]:visible").length?d.children("ul").children("li:last").find("a:first").focus():d.length&&d.find("a:first").focus().length||(a=a.parent().closest("li[role=treeitem]"),a.length&&(0>b?a.find("a:first").focus():ca(a,b,!0)))}function O(a){if(a||!y){y=!0;var b,c=f.offset();da=bw.ie?0:window.pageYOffset;
z=f.parent().scrollTop();c.top+=z;K=c.left;L=c.top;M=c.left+f.width();ea=c.top+f.height();J=[];for(var d in l)a=m(d),(a=a.children().first().get(0))&&(b=a.offsetHeight)&&(c=$(a).offset(),c.top+=z,J[d]={x1:c.left,y1:c.top,x2:c.left+a.offsetWidth,y2:c.top+b,on:d==x});f.height()>f.parent().height()&&f.parent().mousemove(function(e){var g=0;e=rcube_event.get_mouse_pos(e);e.y-=f.parent().offset().top;25>e.y&&0<z?g=-1:e.y>f.parent().height()-25&&(g=1);y&&0!=g?t||(t=window.setTimeout(function(){fa(g)},k.scroll_delay)):
t&&(window.clearTimeout(t),t=null)}).mouseleave(function(){t&&(window.clearTimeout(t),t=null)})}}function ha(){y&&(y=!1,t=null,u&&(clearTimeout(u),x=u=null),$("li.droptarget",f).removeClass("droptarget"))}function fa(a){if(y){var b=z;f.parent().get(0).scrollTop+=k.scroll_step*a;z=f.parent().scrollTop();t=null;z!=b&&(t=window.setTimeout(function(){fa(a)},k.scroll_speed))}}function ia(a,b){var c=bw.ie?-document.documentElement.scrollTop:da,d=f.parent().scrollTop(),e=null;a.top=a.y+d-c;if(a.x<K||a.x>=
M||a.top<L||a.top>=ea)return b&&$("li.droptarget",f).removeClass("droptarget"),e;for(var g in J)c=J[g],a.x>=c.x1&&a.x<c.x2&&a.top>=c.y1&&a.top<c.y2?(e=l[g],e.children&&e.children.length&&e.collapsed&&k.autoexpand&&x!=g?(u&&clearTimeout(u),x=g,u=setTimeout(function(){V(x);O(!0);x=null;F&&$.ui.ddmanager.prepareOffsets($.ui.ddmanager.current,null)},k.autoexpand)):u&&x!=g&&(clearTimeout(u),u=x=null),k.check_droptarget(e)?(b&&(m(g).addClass("droptarget"),c.on=!0),e=g):e=null):c.on&&(m(g).removeClass("droptarget"),
c.on=!1);return e}function P(a){a||(a={});if("string"==$.type(a))return"destroy"==a&&(F=null),$("li:not(.virtual)",f).droppable(a),this;Q=a;var b=$.extend({greedy:!0,tolerance:"pointer",hoverClass:"droptarget",addClasses:!1},a);b.activate=function(c,d){O();F=d;a.activate&&a.activate(c,d)};b.deactivate=function(c,d){ha();F=null;a.deactivate&&a.deactivate(c,d)};b.over=function(c,d){ia(rcube_event.get_mouse_pos(c),!1);a.over&&a.over(c,d)};$("li:not(.virtual)",f).droppable(b);return this}function R(a){a||
(a={});if("string"==$.type(a))return"destroy"==a&&(S=null),$("li:not(.virtual)",f).draggable(a),this;T=a;a=$.extend({appendTo:"body",revert:"invalid",iframeFix:!0,addClasses:!1,cursorAt:{left:-20,top:5},create:function(b,c){S=c},helper:function(b){return $("<div>").attr("id","rcmdraglayer").text($.trim($(b.target).first().text()))}},a);$("li:not(.virtual)",f).draggable(a);return this}k=$.extend({id_prefix:"",autoexpand:1E3,selectable:!1,scroll_delay:500,scroll_step:5,scroll_speed:20,save_state:!1,
keyboard:!0,tabexit:!0,parent_focus:!1,check_droptarget:function(a){return!a.virtual}},k||{});var f=$(ja),r=k.data||[],l={},n=null,y=!1,p=!1,E="",G=!1;var ea=M=L=K=void 0;var J=[],u,x,da=0,z=0,t,w,F,S,T,Q,U=f.attr("id")||k.id_prefix||"0",v=this;this.container=f;this.expand=V;this.collapse=C;this.select=H;this.render=function(){if(!1!==v.triggerEvent("renderBefore",r)){f.html("");for(var a=0;a<r.length;a++)r[a].level=0,A(r[a],f);v.triggerEvent("renderAfter",f)}};this.reset=function(a){H("");r=[];l=
{};y=!1;a?(T&&(S&&R("destroy"),R(T)),Q&&(F&&P("destroy"),P(Q)),r=I(f,0)):f.html("");D()};this.drag_start=O;this.drag_end=ha;this.intersects=ia;this.droppable=P;this.draggable=R;this.update=function(a,b,c){var d,e,g=l[a];if(g){var h=m(a);var q=h.parent();if(b.id||b.html||b.children||b.classes||b.parent)b.parent&&(d=l[b.parent])?(q.closest("li").length&&(e=l[B(q.closest("li"))])&&(e.children=$.grep(e.children,function(ka,la){return ka.id!=g.id})),q=m(b.parent).children("ul").first(),d.children||(d.children=
[]),d.children.push(g)):void 0!==b.parent&&(q=f),$.extend(g,b),h=A(g,q,h);g.id!=a&&(delete l[a],l[g.id]=g);c&&Y(h,"string"==typeof c?'[class~="'+c+'"]':"")}};this.insert=function(a,b,c){var d=b?l[b]:null;search_=p;l[a.id]||(state=aa(a.id,a.collapsed),void 0!==state&&(a.collapsed=state),d?(a.level=d.level+1,d.children||(d.children=[]),p=!1,d.children.push(a),b=m(b),1==d.children.length?(A(d,null,b),d=m(a.id)):d=A(a,b.children("ul").first()),search_&&(p=search_,d.is(":visible")||$("<li>").attr("id",
d.attr("id")+"--xsR").attr("class",d.attr("class")).addClass("searchresult__").append(d.children().first().clone(!0,!0)).appendTo(f))):(a.level=0,r.push(a),d=A(a,f)),l[a.id]=a,"object"==typeof a.html&&(l[a.id].html=m(a.id,!0).children()),c&&Y(d,"string"==typeof c?'[class~="'+c+'"]':""))};this.remove=function(a){var b;if(b=l[a]){var c=m(a,!0);var d=c.parent();c.remove();b.deleted=!0;delete l[a];p&&m(a,!1).remove();d.children().length||(d.parent().find("div.treetoggle").remove(),d.remove());return!0}return!1};
this.get_item=X;this.get_node=function(a){return l[a]};this.get_selection=function(){return n};this.is_search=function(){return p};this.reset_search=D;if(f.length){k.data?ba({children:r}):r=I(f,0);n&&W(m(n,!0));f.attr("role","tree").on("focusin",function(a){G=!0}).on("focusout",function(a){G=!1}).on("click","div.treetoggle",function(a){var b=B($(this).parent()),c;(c=l[b])&&C(b,void 0,!c.collapsed);a.stopPropagation()}).on("click","li",function(a){if($(a.target).is("input"))return!0;var b=k.selectable?
l[B($(this))]:null;b&&!b.virtual&&(H(b.id),a.stopPropagation())}).on("mousedown","a",function(a){var b=$(a.target),c=l[B(b.closest("li"))];if(c&&c.virtual&&!b.attr("href"))return a.preventDefault(),a.stopPropagation(),!1});if(k.searchbox){var N=$(k.searchbox).off("keyup.treelist").on("keyup.treelist",function(a){var b=rcube_event.get_keycode(a);rcube_event.get_modifier(a);switch(b){case 9:break;case 13:return Z(this.value,!0),rcube_event.cancel(a);case 27:D();break;case 38:case 37:case 39:case 40:break;
default:Z(this.value,!1)}}).attr("autocomplete","off");N.parent().find("a.reset").off("click.treelist").on("click.treelist",function(a){D();return!1})}$(document.body).on("keydown",function(a){var b=a.target||{},c=rcube_event.get_keycode(a);if(!G||"INPUT"==b.nodeName&&38!=c&&40!=c||"TEXTAREA"==b.nodeName||"SELECT"==b.nodeName)return!0;switch(c){case 38:case 40:case 63232:case 63233:return b=k.keyboard?f.find(":focus").closest("li"):[],b.length&&ca(b,mod=38==c||63232==c?-1:1),rcube_event.cancel(a);
case 37:case 39:var d;b=f.find(":focus").closest("li");if(b.length&&(b=B(b),(d=l[b])&&d.children.length&&d.collapsed!=(37==c))){a=rcube_event.get_modifier(a)==SHIFT_KEY;var e;(e=l[b])&&C(b,a,!e.collapsed)}return!1;case 9:k.keyboard&&k.tabexit&&(e=rcube_event.get_modifier(a)==SHIFT_KEY?"first":"last",e=f.find("li[role=treeitem]:has(a)")[e]().find("a:"+e),e.length&&(a=f.parent().get(0)||{scrollTop:0},c=a.scrollTop||a.scrollY,e.focus(),a.scrollTop=c))}return!0});k.parent_focus&&f.parent(":not(body)").click(function(a){if($(a.target).is("input"))return!0;
!G&&n?$(X(n)).find(":focusable").first().focus():G||f.children("li:has(:focusable)").first().find(":focusable").first().focus()})}}rcube_treelist_widget.prototype.addEventListener=rcube_event_engine.prototype.addEventListener;rcube_treelist_widget.prototype.removeEventListener=rcube_event_engine.prototype.removeEventListener;rcube_treelist_widget.prototype.triggerEvent=rcube_event_engine.prototype.triggerEvent;
